package com.zt.demo.controller;

import com.zt.demo.pojo.RequestParams;
import com.zt.demo.service.RequestParamsService;
import jakarta.validation.Valid;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/api")
@Slf4j
@Validated
public class ApiController {
    @Autowired
    private RequestParamsService requestParamsService;

    @PostMapping("/post")
    public ResponseEntity<String> postRequest(@RequestHeader(value = "reqId", required = false) String reqId, @Valid @RequestBody RequestParams params) {
        String result = requestParamsService.handlePostRequest(params);
        log.info(result.toString());
        return new ResponseEntity<>(result, HttpStatus.OK);
    }

    @GetMapping("/get")
    public ResponseEntity<String> getRequest(@RequestHeader(value = "reqId", required = false) String reqId, @Valid RequestParams params) {
        String result = requestParamsService.handleGetRequest(params);
        log.info(result.toString());
        return new ResponseEntity<>(result, HttpStatus.OK);
    }
}
